import sidebar from './sidebar';
import collect from './collect';
import { FETCH_START, FETCH_DONE } from './mutation-types';
const GET_WHITE_LIST = 'GET_WHITE_LIST';

let fetchCount = 0;
const state = () => ({
  loading: false,
  whiteList: [],
});

const getters = {
  loading: state => state.loading,
  whiteList: state => state.whiteList,
};

const actions = {
  fetchStart({ commit }, notLoading) {
    commit(FETCH_START, notLoading);
  },
  fetchDone({ commit }, notLoading) {
    commit(FETCH_DONE, notLoading);
  },
  getWhiteList({ commit }, list) {
    commit(GET_WHITE_LIST, list);
  },
};
const mutations = {
  [FETCH_START](state, notLoading) {
    if (!notLoading) {
      fetchCount++;
      state.loading = true;
    }
  },
  [FETCH_DONE](state, notLoading) {
    if (!notLoading) {
      fetchCount--;
    }
    if (fetchCount === 0) {
      state.loading = false;
    }
  },
  [GET_WHITE_LIST](state, list) {
    state.whiteList = [...state.whiteList, ...list];
  },
};
export default {
  modules: {
    sidebar,
    collect,
  },
  state,
  getters,
  actions,
  mutations,
};
